/* WARNING: this file is generated by modbus_server/Makefile.mk */
/* WARNING: modbus_server */
/** @file modbuscli.c MODBUS/TCP/UDP client sample for the MSXE331x
 *
 * FC16 queries are for setting things, FC3 for fetching values
 *
 * This code doesn't handle timeouts.
 */

#ifdef WIN32
	#include "../../Interface_Library/msxe331x_modbus_clientlib.h"
#else
	#include <msxe331x_modbus_clientlib.h>
#endif

#ifdef WIN32
	#include <windows.h>
	#define sleep(a) Sleep(a*1000)
#else
	#include <unistd.h>
#endif

#include <modbusclient.h>
#include <commonclient.h>

#include <addidata_console.h>
#include <addidata_network.h>
#include <addidata_dataclient.h>

	uint32_t ulNbrOfAcquisitionChannels    = 0;
	uint32_t ulNbrOfSequence               = 100;
	uint32_t ulAcquisitionChannelType [16] = {0};

// Get the acquisition channels information
int sample_MSXE331x__AcquisitionGetInformations (struct modbus * modbus)
{
	struct MSXE331x__AcquisitionGetNumberOfChannels_parameters_t ResponseGetChannels;
	struct MSXE331x__AcquisitionGetChannelsInfo_parameters_t     ResponseChannelInfo;
	int       iRet          = 0;
	uint32_t ulChannels     = 0;
	char      cType [9][32] = {"not available", "temperature", "pressure", "transducer", "analog input", "analog input ICP", "digital I/O port","incremental counter", "sine/cosine"};

	printf ("\nGet acquisition channels informations:\n");
	printf ("--------------------------------------\n");

	memset(&ResponseGetChannels,0,sizeof(ResponseGetChannels));
	memset(&ResponseChannelInfo,0,sizeof(ResponseChannelInfo));

	/* Get the number of acquisition channels */
	iRet = modbus_call_MSXE331x__AcquisitionGetNumberOfChannels(modbus, &ResponseGetChannels);
	if ( handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE331x__AcquisitionGetNumberOfChannels") )
	{
		return -1;
	}

	/* store */
	ulNbrOfAcquisitionChannels = ResponseGetChannels.ulNumber;
	printf ("Number of available acquisition channel(s) : %u\n", ulNbrOfAcquisitionChannels);

	/* Get the channels info */
	iRet = modbus_call_MSXE331x__AcquisitionGetChannelsInfo (modbus, &ResponseChannelInfo);
	if ( handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE331x__AcquisitionGetChannelsInfo") )
	{
		return -1;
	}

	/* display an store */
	for (ulChannels = 0; ulChannels < ulNbrOfAcquisitionChannels; ulChannels++)
	{
		printf("Acquisition channel %2d connected to connector %u is a %s channel \n",ulChannels, ResponseChannelInfo.ulHwPosition[ulChannels], cType[ResponseChannelInfo.ulType[ulChannels]]);
		ulAcquisitionChannelType[ulChannels] = ResponseChannelInfo.ulType[ulChannels];
	}

	printf("\nPress a key to continue\n");
	fflush(stdout);
	addidata_console_wait_for_input();
	return 0;
}

// Pressure initialisation
int sample_MSXE331x__PressureChannelsInitialisation(struct modbus * modbus)
{
	struct MSXE331x__PressureGetNumberOfChannels_parameters_t   ResponseGetChannels;
	struct GetLastCommandStatus_parameters_t                               ResponseSetConfiguration;
	struct GetLastCommandStatus_parameters_t                               ResponseSetSamplingRate;
	int       iRet         = 0;
	uint32_t ulChannels    = 0;

	printf ("\nPressure channel(s) initialisation:\n");
	printf ("-----------------------------------\n");

	memset(&ResponseGetChannels,0,sizeof(ResponseGetChannels));

	iRet = modbus_call_MSXE331x__PressureGetNumberOfChannels(modbus, &ResponseGetChannels);

	if ( !handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE331x__PressureGetNumberOfChannels") )
	{
		for (ulChannels = 0; ulChannels < ResponseGetChannels.ulNumber; ulChannels ++)
		{
			printf("Pressure channel %2d configuration : 1.0 sensor sensibility (mV/Vr/bar)", ulChannels);

			// Set the sensor sensibility to 1
			iRet = modbus_call_MSXE331x__PressureSetChannelConfiguration (modbus, (unsigned long) ulChannels, (float) 1.0, (float) 0.0, 0, &ResponseSetConfiguration);

			if (handle_result_of_FC16_query(modbus, &ResponseSetConfiguration, iRet, "modbus_call_MSXE331x__PressureSetChannelConfiguration"))
			{
				return (-1);
			}

			if ((ulChannels % 2) == 1)
			{
				printf ("Set the sampling rate for channel(s) %2d and %2d to 160Hz.\n\n", ulChannels - 1, ulChannels);

				iRet = modbus_call_MSXE331x__PressureSetSamplingRate (modbus, (unsigned long) (ulChannels >> 1), 160, 0, &ResponseSetSamplingRate);

				if (handle_result_of_FC16_query(modbus, &ResponseSetSamplingRate, iRet, "modbus_call_MSXE331x__PressureSetSamplingRate" ))
				{
					return (-1);
				}
			}
		}

		printf("\nPress a key to continue\n");
		fflush(stdout);
		addidata_console_wait_for_input();

		return (0);
	}
	return (-1);
}

// Auto refresh start
int sample_MSXE331x__AcquisitionAutoRefreshInitAndStart (struct modbus * modbus)
{
	struct GetLastCommandStatus_parameters_t Response;
	int      iRet                         = 0;
	uint32_t ulChannelMask                = (1 << ulNbrOfAcquisitionChannels) - 1;
	uint32_t ulAverageValue               = 1;
	uint32_t ulRefreshTime                = 200;
	uint32_t ulRefreshTimeUnit            = 1;
	uint32_t ulTriggerMask                = 0;
	uint32_t ulTriggerMode                = 0;
	uint32_t ulHardwareTriggerEdge        = 0;
	uint32_t ulHardwareTriggerCount       = 0;
	uint32_t ulByTriggerNbrOfSeqToAcquire = 0;
	uint32_t ulDataFormat                 = 0x1D;
	uint32_t ulForceStart                 = 1;
	uint32_t ulOption1                    = 0;
	uint32_t ulOption2                    = 0;
	uint32_t ulOption3                    = 0;

	printf("\nPress a key to start the auto refresh acquisition.\n");
	printf("--------------------------------------------------\n");
	fflush(stdout);
	addidata_console_wait_for_input();

	printf ("\nAuto refresh acquistion initialisation and start:\n");
	printf ("-------------------------------------------------\n");

	printf ("Channel mask                : %04X Hex\n", ulChannelMask);
	printf ("Average value               : %u\n",       ulAverageValue);
	printf ("Refresh time                : %u\n",       ulRefreshTime);
	printf ("Refresh time unit           : %u\n",       ulRefreshTimeUnit);
	printf ("Trigger mask                : %X Hex\n",   ulTriggerMask);
	printf ("Trigger mode                : %X Hex\n",   ulTriggerMode);
	printf ("HW trigger edge             : %u\n",       ulHardwareTriggerEdge);
	printf ("HW trigger count            : %u\n",       ulHardwareTriggerCount);
	printf ("HW trigger seq. to acquire  : %u\n",       ulByTriggerNbrOfSeqToAcquire);
	printf ("Data format                 : %X Hex\n",   ulDataFormat);

	iRet = modbus_call_MSXE331x__AcquisitionAutoRefreshInitAndStart (modbus,
	                                                                            ulChannelMask,
	                                                                            ulAverageValue,
	                                                                            ulRefreshTime,
	                                                                            ulRefreshTimeUnit,
	                                                                            ulTriggerMask,
	                                                                            ulTriggerMode,
	                                                                            ulHardwareTriggerEdge,
	                                                                            ulHardwareTriggerCount,
	                                                                            ulByTriggerNbrOfSeqToAcquire,
	                                                                            ulDataFormat,
	                                                                            ulForceStart,
	                                                                            ulOption1,
	                                                                            ulOption2,
	                                                                            ulOption3,
	                                                                            &Response);

	if (!iRet)
	{
		printf ("OK\n");
	}

	//Return value check
	return handle_result_of_FC16_query(modbus, &Response, iRet, "modbus_call_MSXE331x__AcquisitionAutoRefreshInitAndStart" );
}

// Auto refresh read
int sample_MSXE331x__AcquisitionAutoRefreshGetBlockingValues(struct modbus * modbus)
{
	struct MSXE331x__AcquisitionAutoRefreshGetBlockingValues_parameters_t Response;
	int       iRet      = 0;
	uint32_t ulChannels = 0;

	memset(&Response,0,sizeof(Response));

	/* Get a value from the auto-refresh acquisition and display it */
	iRet = modbus_call_MSXE331x__AcquisitionAutoRefreshGetBlockingValues(modbus, &Response);
	if ( handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE331x__AcquisitionAutoRefreshGetBlockingValues") )
	{
		return -1;
	}

	/**
	 *  Display the value.
	 *  The algorithm assumes that the "Data Format" analog is selected
	 *  */
	printf("Counter: %10u\ts: %10u\tmicro s:%6u\n",Response.ulCounterValue,Response.ulTimeStampHigh, Response.ulTimeStampLow);
	for (ulChannels = 0; ulChannels < ulNbrOfAcquisitionChannels; ulChannels ++)
	{
		switch (ulAcquisitionChannelType[ulChannels])
		{
			case 0:
			case 1:
			case 2:
			case 3:
			case 4:
			case 5:
			case 8:
				/* Types 0,1,2,3,4,5,8 supports float conversion */
				printf("\tChannel %d = %f\n", ulChannels, Response.fValues[ulChannels]);
				break;
			case 6:
			case 7:
				/* Types 6 and 7 does not support float conversion */
				{
					int iValue = (int)Response.fValues[ulChannels];
					printf("\tChannel %d = %d\n", ulChannels, iValue);
					break;
				}
			default:
				printf("\tChannel %d = %f\n", ulChannels, Response.fValues[ulChannels]);
		}
	}

	return 0;
}

// Auto refresh release
int sample_MSXE331x__AcquisitionAutoRefreshStopAndRelease (struct modbus * modbus)
{
	struct GetLastCommandStatus_parameters_t Response;
	int      iRet      = 0;
	uint32_t ulOption1 = 0;

	printf ("\nStop and release the auto refresh acquisition:\n");
	printf ("----------------------------------------------\n");

	iRet = modbus_call_MSXE331x__AcquisitionAutoRefreshStopAndRelease (modbus, ulOption1, &Response);

	if (!iRet)
	{
		printf ("OK\n");
	}

	//Return value check
	return handle_result_of_FC16_query(modbus, &Response, iRet, "modbus_call_MSXE331x__AcquisitionAutoRefreshStopAndRelease" );
}

// Auto refresh get configuration
int sample_MSXE331x__AcquisitionAutoRefreshGetConfiguration (struct modbus * modbus)
{
	struct MSXE331x__AcquisitionAutoRefreshGetConfiguration_parameters_t Response;
	int iRet = 0;

	memset(&Response,0,sizeof(Response));

	printf ("\nLast auto refresh acquisition configuration:\n");
	printf ("--------------------------------------------\n");

	iRet = modbus_call_MSXE331x__AcquisitionAutoRefreshGetConfiguration(modbus, &Response);

	if ( !handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE331x__AcquisitionAutoRefreshGetConfiguration") )
	{
		printf ("Channel mask                : %04X Hex\n", Response.ulChannelMask);
		printf ("Average value               : %u\n",       Response.ulAverageValue);
		printf ("Refresh time                : %u\n",       Response.ulRefreshTime);
		printf ("Refresh time unit           : %u\n",       Response.ulRefreshTimeUnit);
		printf ("Trigger mask                : %X Hex\n",   Response.ulTriggerMask);
		printf ("Trigger mode                : %X Hex\n",   Response.ulTriggerMode);
		printf ("HW trigger edge             : %u\n",       Response.ulHardwareTriggerEdge);
		printf ("HW trigger count            : %u\n",       Response.ulHardwareTriggerCount);
		printf ("HW trigger seq. to acquire  : %u\n",       Response.ulByTriggerNbrOfSeqToAcquire);
		printf ("Data format                 : %X Hex\n",   Response.ulDataFormat);
		printf ("Running                     : %u\n",       Response.ulRunning);

		printf("\nPress a key to continue\n");
		fflush(stdout);
		addidata_console_wait_for_input();

		return 0;
	}
	return -1;
}

// Sequence start
int sample_MSXE331x__AcquisitionSequenceInitAndStart (struct modbus * modbus)
{
	struct GetLastCommandStatus_parameters_t Response;
	int      iRet                         = 0;
	uint32_t ulChannels                   = 0;
	uint32_t ulNbrOfChannel               = ulNbrOfAcquisitionChannels;
	uint32_t ulChannelList [16];
	uint32_t ulAcquisitionTime            = 100;
	uint32_t ulAcquisitionTimeUnit        = 1;
	uint32_t ulNbrMaxSequenceToTransfer   = 2;
	uint32_t ulTriggerMask                = 0;
	uint32_t ulTriggerMode                = 0;
	uint32_t ulHardwareTriggerEdge        = 0;
	uint32_t ulHardwareTriggerCount       = 0;
	uint32_t ulByTriggerNbrOfSeqToAcquire = 0;
	uint32_t ulDataFormat                 = 0x1D;
	uint32_t ulForceStart                 = 1;
	uint32_t ulOption1                    = 0;
	uint32_t ulOption2                    = 0;
	uint32_t ulOption3                    = 0;

	printf ("\nSequence acquisition initialisation and start:\n");
	printf ("---------------------------------------------\n");

	printf ("Number of selected channels     : %u\n",       ulNbrOfChannel);
	printf ("Acquisition time                : %u\n",       ulAcquisitionTime);
	printf ("Acquisition time unit           : %u\n",       ulAcquisitionTimeUnit);
	printf ("Number of sequences             : %u\n",       ulNbrOfSequence);
	printf ("Number of sequences to transfer : %u\n",       ulNbrMaxSequenceToTransfer);
	printf ("Trigger mask                    : %X Hex\n",   ulTriggerMask);
	printf ("Trigger mode                    : %X Hex\n",   ulTriggerMode);
	printf ("HW trigger edge                 : %u\n",       ulHardwareTriggerEdge);
	printf ("HW trigger count                : %u\n",       ulHardwareTriggerCount);
	printf ("HW trigger seq. to acquire      : %u\n",       ulByTriggerNbrOfSeqToAcquire);
	printf ("Data format                     : %X Hex\n\n", ulDataFormat);

	for (ulChannels = 0; ulChannels < ulNbrOfChannel; ulChannels ++)
	{
		ulChannelList[ulChannels] = ulChannels;
	}

	iRet = modbus_call_MSXE331x__AcquisitionSequenceInitAndStart (modbus,
	                                                                         ulNbrOfChannel,
	                                                                         ulChannelList,
	                                                                         ulAcquisitionTime,
	                                                                         ulAcquisitionTimeUnit,
	                                                                         ulNbrOfSequence,
	                                                                         ulNbrMaxSequenceToTransfer,
	                                                                         ulTriggerMask,
	                                                                         ulTriggerMode,
	                                                                         ulHardwareTriggerEdge,
	                                                                         ulHardwareTriggerCount,
	                                                                         ulByTriggerNbrOfSeqToAcquire,
	                                                                         ulDataFormat,
	                                                                         ulForceStart,
	                                                                         ulOption1,
	                                                                         ulOption2,
	                                                                         ulOption3,
	                                                                         &Response);

	//Return value check
	return handle_result_of_FC16_query(modbus, &Response, iRet, "modbus_call_MSXE331x__AcquisitionSequenceInitAndStart" );
}

// Sequence release
int sample_MSXE331x__AcquisitionSequenceStopAndRelease (struct modbus * modbus)
{
	struct GetLastCommandStatus_parameters_t Response;
	int      iRet      = 0;
	uint32_t ulOption1 = 0;

	printf ("\nStop and release the sequence acquistion:\n");
	printf ("-----------------------------------------\n");

	iRet = modbus_call_MSXE331x__AcquisitionSequenceStopAndRelease (modbus, ulOption1, &Response);

	if (!iRet)
	{
		printf ("OK\n");
	}

	//Return value check
	return handle_result_of_FC16_query(modbus, &Response, iRet, "modbus_call_MSXE331x__AcquisitionSequenceStopAndRelease" );
}

// Auto refresh get configuration
int sample_MSXE331x__AcquisitionSequenceGetConfiguration (struct modbus * modbus)
{
	struct MSXE331x__AcquisitionSequenceGetConfiguration_parameters_t Response;
	int iRet = 0;

	memset(&Response,0,sizeof(Response));

	printf ("\nLast sequence acquisition configuration:\n");
	printf ("----------------------------------------\n");

	iRet = modbus_call_MSXE331x__AcquisitionSequenceGetConfiguration(modbus, &Response);

	if ( !handle_result_of_FC3_query(modbus, iRet, "modbus_call_MSXE331x__AcquisitionSequenceGetConfiguration") )
	{
		printf ("Number of selected channels     : %u\n",       Response.ulNbrOfChannel);
		printf ("Acquisition time                : %u\n",       Response.ulAcquisitionTime);
		printf ("Acquisition time unit           : %u\n",       Response.ulAcquisitionTimeUnit);
		printf ("Number of sequences             : %u\n",       Response.ulNbrOfSequence);
		printf ("Number of sequences to transfer : %u\n",       Response.ulNbrMaxSequenceToTransfer);
		printf ("Trigger mask                    : %X Hex\n",   Response.ulTriggerMask);
		printf ("Trigger mode                    : %X Hex\n",   Response.ulTriggerMode);
		printf ("HW trigger edge                 : %u\n",       Response.ulHardwareTriggerEdge);
		printf ("HW trigger count                : %u\n",       Response.ulHardwareTriggerCount);
		printf ("HW trigger seq. to acquire      : %u\n",       Response.ulByTriggerNbrOfSeqToAcquire);
		printf ("Data format                     : %X Hex\n",   Response.ulDataFormat);
		printf ("Running                         : %u\n",       Response.ulRunning);

		printf("\nPress a key to continue\n");
		fflush(stdout);
		addidata_console_wait_for_input();

		return 0;
	}
	return -1;
}

//---------------------------------------------------------------------------------
static void usage(char* name)
{
	printf("%s ADDRESS tcp|udp\n",name);
}

//---------------------------------------------------------------------------------

int main(int argc, char** argv)
{
	struct modbus modbus;
	int contype = SOCK_DGRAM;
	int       iFd = 0;
	uint32_t ulDatas[16 + 4];
	float*   pfDatas      = (float *) &ulDatas[4];
	uint32_t ulChannels   = 0;
	uint32_t ulCount      = 0;
	uint32_t ulFrameCount = 0;

	if (argc != 3)
	{
		usage(argv[0]);
		exit(1);
	}

	if (0 == strcmp(argv[2],"tcp"))
	{
		contype=SOCK_STREAM;
	}
	else if(0 == strcmp(argv[2],"udp"))
	{
		contype=SOCK_DGRAM;
	}
	else
	{
		usage(argv[0]);
		exit(1);
	}

	modbus_init(&modbus);

	switch( modbus_connect(&modbus, argv[1], contype, 0) )
	{
		case 0: /* success */
			break;
		case -1: /* system error */
			addidata_network_perror("modbus_connect");
			exit(1);
		case -2: /* parameter is incorrect */
			printf("modbus_connect: incorrect parameter\n");
			exit(1);
		case -3: /* incorrect address */
			printf("incorrect address\n");
			exit(1);
	}

	assert( sample_MSXE331x__AcquisitionGetInformations(&modbus) == 0);

	// Pressure initialisation
	assert( sample_MSXE331x__PressureChannelsInitialisation(&modbus) == 0);

	/* autorefresh */
	assert( sample_MSXE331x__AcquisitionAutoRefreshInitAndStart(&modbus) == 0);
	{
		int i;
		for(i=0;i<100;i++)
		{
			printf("Value %d/100\n", i);
			assert( sample_MSXE331x__AcquisitionAutoRefreshGetBlockingValues(&modbus) == 0);
		}
	}

	assert( sample_MSXE331x__AcquisitionAutoRefreshStopAndRelease(&modbus) == 0);

	assert( sample_MSXE331x__AcquisitionAutoRefreshGetConfiguration(&modbus) == 0);

	printf("\nPress a key to start the sequence acquisition.\n");
	printf("----------------------------------------------\n");
	fflush(stdout);
	addidata_console_wait_for_input();

	/* connect to data server */
	switch(addidata_dataclient_tcp_connect(argv[1], 0, &iFd))
	{
		case 0: /* OK */
			break;
		case -1:
			addidata_network_perror("socket");
			exit(1);
		case -2:
			addidata_network_perror("connect");
			exit(1);
		case -3:
			printf("error while parsing address\n");
			exit(1);
		case -4:
			addidata_network_perror("WSACleanup() failed");
			exit(1);
	}

	/* sequence */
	assert( sample_MSXE331x__AcquisitionSequenceInitAndStart(&modbus) == 0);

	ulCount = ulNbrOfAcquisitionChannels + 4;

	/**
	 * Receive all the frames from the system
	 * The algorithm assumes that the "Data Format" is analog
	 * The algorithm also assumes that the sequence list is the list of the acquisition channels
	 * of the system in the right order
	 */
	for(ulFrameCount=0; ulFrameCount < ulNbrOfSequence; ulFrameCount++)
	{
		printf("Value %u/%u\n", ulFrameCount, ulNbrOfSequence);

		/* receive per socket */
		if( -1 == addidata_dataclient_recvall(iFd, ulDatas, (int) ulCount) )
		{
			addidata_network_perror("fetch");
			assert( sample_MSXE331x__AcquisitionSequenceStopAndRelease(&modbus) == 0);
			exit(1);
		}

		/* display */
		printf("Counter: %10u\ts: %10u\tmicro s:%6u\tSystem status information :%u\n",ulDatas[2],ulDatas[0],ulDatas[1],ulDatas[3]);
		for (ulChannels = 0; ulChannels < (ulCount - 4); ulChannels ++)
		{
			switch (ulAcquisitionChannelType[ulChannels])
			{
				case 0:
				case 1:
				case 2:
				case 3:
				case 4:
				case 5:
				case 8:
					/* Types 0,1,2,3,4,5,8 supports float conversion */
					printf("\tChannel %d = %f\n", ulChannels, pfDatas[ulChannels]);
					break;
				case 6:
				case 7:
					/* Types 6 and 7 does not support float conversion */
					printf("\tChannel %d = %u\n", ulChannels, ulDatas[4 + ulChannels]);
					break;
				default:
					printf("\tChannel %d = %f\n", ulChannels, pfDatas[ulChannels]);
			}
		}
	}

	addidata_dataclient_disconnect(iFd);

	assert( sample_MSXE331x__AcquisitionSequenceStopAndRelease(&modbus) == 0);

	assert( sample_MSXE331x__AcquisitionSequenceGetConfiguration(&modbus) == 0);

	printf("\nPress a key to end this sample\n");
	fflush(stdout);
	addidata_console_wait_for_input();

	return 0;
}
/* WARNING: this file is generated by modbus_server/Makefile.mk */
