using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;


namespace Initialisation
{
    public partial class FInitialisation : Form
    {
        // Global Variable
        private MXCommon_WebReference.MXCommon MX_Common;
        private MSXExxxx_WebReference.MSXExxxx MSXExxxx;
        private MXCommon_WebReference.DefaultResponse MXResponse;
        private MSXExxxx_WebReference.DefaultResponse Response;
        private GroupBox[] g_ChannelGroups = new GroupBox[8];
        private CheckBox[] g_Channels = new CheckBox[16];
        private TextBox[] g_ChannelSensibilityValue = new TextBox[16];
        private TextBox[] g_ChannelOffsetValue = new TextBox[16];
        private ComboBox[] g_SamplingRate = new ComboBox[8];
        private ulong g_ulNbrOfChannels = 0;
        private int g_RetValue = 0;
        private int g_syserrno = 0;

        public FInitialisation()
        {
            InitializeComponent();
        }
        public class ListData
        {
            private string myItem;
            private long myValue;

            public ListData(string Item, long Value)
            {

                this.myItem = Item;
                this.myValue = Value;
            }

            public string Item
            {
                get { return myItem; }
            }

            public long Value
            {

                get { return myValue; }
            }
        }


        private void Combobox_set_SelectedValue(ComboBox cb, long value)
        {
            for (int Cpt = 0; Cpt < cb.Items.Count; Cpt++)
            {
                if (Convert.ToInt64(((ListData)cb.Items[Cpt]).Value) == value)
                {
                    cb.SelectedIndex = Cpt;
                    break;
                }
            }

        }

        private void GetConfiguration()
        {
            Double dSensibility = 0.0;
            Double dOffset = 0.0;
            UInt64 ulBaseSamplingRate = 0;
            

            for (ulong ulCpt = 0; ulCpt < g_ulNbrOfChannels; ulCpt++)
            {

                try
                {
                    Response = MSXExxxx.PressureGetConfiguration(ulCpt,0, out dSensibility,out dOffset, out ulBaseSamplingRate);
                    if (Response.iReturnValue != 0)
                    {
                        MessageBox.Show("PressureGetConfiguration  Error : " + Response.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    }

                    g_ChannelSensibilityValue[ulCpt].Text = dSensibility.ToString().Replace(",", ".");
                    g_ChannelOffsetValue[ulCpt].Text = dOffset.ToString().Replace(",", ".");

                    ArrayList ALSamplingRate = new ArrayList();
                    ALSamplingRate.Add(new ListData("5 Hz", 5));
                    ALSamplingRate.Add(new ListData("10 Hz", 10));
                    ALSamplingRate.Add(new ListData("20 Hz", 20));
                    ALSamplingRate.Add(new ListData("40 Hz", 40));
                    ALSamplingRate.Add(new ListData("80 Hz", 80));
                    ALSamplingRate.Add(new ListData("160 Hz", 160));
                    ALSamplingRate.Add(new ListData("320 Hz", 320));
                    ALSamplingRate.Add(new ListData("640 Hz", 640));
                    ALSamplingRate.Add(new ListData("1000 Hz", 1000));
                    ALSamplingRate.Add(new ListData("2000 Hz", 2000));

                    g_SamplingRate[ulCpt / 2].DisplayMember = "Item";
                    g_SamplingRate[ulCpt / 2].ValueMember = "Value";
                    g_SamplingRate[ulCpt / 2].DataSource = ALSamplingRate;

                    Combobox_set_SelectedValue(g_SamplingRate[ulCpt / 2],(long)ulBaseSamplingRate);


                }
                catch (Exception ex)
                {
                    MessageBox.Show("PressureGetConfiguration  Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    return;
                }

            }


        }

                
        private void SetConfiguration()
        {

            for (ulong ulCpt = 0; ulCpt < g_ulNbrOfChannels; ulCpt++)
            {

                if (g_Channels[ulCpt].Enabled == true)
                {
                    try
                    {
                        g_RetValue = MSXExxxx.PressureSetSamplingRate(ulCpt / 2, Convert.ToUInt64(g_SamplingRate[ulCpt / 2].SelectedValue), 0, out g_syserrno);
                        if (g_RetValue != 0)
                        {
                            MessageBox.Show("PressureSetSamplingRate  Error : " + g_RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            return;
                        }
                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show("PressureSetSamplingRate  Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    }

                    try
                    {
                        g_RetValue = MSXExxxx.PressureSetChannelConfiguration(ulCpt, Convert.ToDouble(g_ChannelSensibilityValue[ulCpt].Text.Replace(".", ",")), Convert.ToDouble(g_ChannelOffsetValue[ulCpt].Text.Replace(".", ",")), 0, out g_syserrno);
                        if (g_RetValue != 0)
                        {
                            MessageBox.Show("PressureSetChannelConfiguration  Error : " + g_RetValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            return;
                        }
                    }
                    catch (Exception ex)
                    {
                        MessageBox.Show("PressureSetChannelConfiguration  Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        return;
                    }
                }
            }

        }
        private void B_Connect_Click(object sender, EventArgs e)
        {
            System.Text.ASCIIEncoding enc = new System.Text.ASCIIEncoding();
            byte[] pcName = new byte[255];


            if ((TB_IPAddress_0.Text.ToString() == "") || (TB_IPAddress_1.Text.ToString() == "") || (TB_IPAddress_2.Text.ToString() == "") || (TB_IPAddress_3.Text.ToString() == ""))
            {
                MessageBox.Show("The IP address you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
            }
            else
            {
                if ((Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_0.Text.ToString(), 10) < 256))
                {
                    if ((Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_1.Text.ToString(), 10) < 256))
                    {
                        if ((Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_2.Text.ToString(), 10) < 256))
                        {
                            if ((Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) >= 0) && (Convert.ToUInt64(TB_IPAddress_3.Text.ToString(), 10) < 256))
                            {
                                B_SetConfiguration.Enabled = false;
                                MX_Common.Url = "http://" + TB_IPAddress_0.Text + "." + TB_IPAddress_1.Text + "." + TB_IPAddress_2.Text + "." + TB_IPAddress_3.Text + ":5555";
                                MSXExxxx.Url = MX_Common.Url;

                                // Get the module type
                                try
                                {
                                    MXResponse = MX_Common.GetModuleType(out pcName);
                                    if (MXResponse.iReturnValue != 0)
                                    {
                                        MessageBox.Show("GetModuleType Error : " + MXResponse.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                        return;
                                    }

                                }
                                catch (Exception ex)
                                {
                                    MessageBox.Show("GetModuleType Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                    return;
                                }


                                try
                                {
                                    Response = MSXExxxx.PressureGetNumberOfChannels(0, out g_ulNbrOfChannels);
                                    if (Response.iReturnValue != 0)
                                    {
                                        MessageBox.Show("PressureGetNumberOfChannels Error : " + Response.iReturnValue.ToString(), "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                        return;
                                    }

                                }
                                catch (Exception ex)
                                {
                                    MessageBox.Show("PressureGetNumberOfChannels Exception occur : " + ex.Message, "Function error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                                    return;
                                }

                                for (ulong i = 0; i < g_ulNbrOfChannels; i++)
                                {
                                    g_Channels[i].Enabled = true;
                                    g_Channels[i].Checked = true;
                                    g_ChannelGroups[i / 2].Enabled = true;
                                }

                                for (ulong i = g_ulNbrOfChannels; i < 16; i++)
                                {
                                    g_Channels[i].Enabled = false;
                                    g_Channels[i].Checked = false;
                                    g_ChannelGroups[i / 2].Enabled = false;
                                }

                                GetConfiguration();
                                B_SetConfiguration.Enabled = true;
                                GB_ChannelConfiguration.Enabled = true;
                            }
                            else
                            {
                                MessageBox.Show("The IP address (part 4) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                            }
                        }
                        else
                        {
                            MessageBox.Show("The IP address (part 3) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                        }
                    }
                    else
                    {
                        MessageBox.Show("The IP address (part 2) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                    }
                }
                else
                {
                    MessageBox.Show("The IP address (part 1) you enter is not valid, please try again.", "IP address error", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                }
            }

        }

        private void FInitialisation_Load(object sender, EventArgs e)
        {
            MX_Common = new MXCommon_WebReference.MXCommon();
            MSXExxxx = new MSXExxxx_WebReference.MSXExxxx();
            MX_Common.Timeout = 5000;
            MSXExxxx.Timeout = 5000;

            // Save the auto refresh channels check box
            g_Channels[0] = CB_Channel0;
            g_Channels[1] = CB_Channel1;
            g_Channels[2] = CB_Channel2;
            g_Channels[3] = CB_Channel3;
            g_Channels[4] = CB_Channel4;
            g_Channels[5] = CB_Channel5;
            g_Channels[6] = CB_Channel6;
            g_Channels[7] = CB_Channel7;
            g_Channels[8] = CB_Channel8;
            g_Channels[9] = CB_Channel9;
            g_Channels[10] = CB_Channel10;
            g_Channels[11] = CB_Channel11;
            g_Channels[12] = CB_Channel12;
            g_Channels[13] = CB_Channel13;
            g_Channels[14] = CB_Channel14;
            g_Channels[15] = CB_Channel15;


            g_ChannelGroups[0] = GB_Group0;
            g_ChannelGroups[1] = GB_Group1;
            g_ChannelGroups[2] = GB_Group2;
            g_ChannelGroups[3] = GB_Group3;
            g_ChannelGroups[4] = GB_Group4;
            g_ChannelGroups[5] = GB_Group5;
            g_ChannelGroups[6] = GB_Group6;
            g_ChannelGroups[7] = GB_Group7;


            g_ChannelSensibilityValue[0] = TB_Sensibility0;
            g_ChannelSensibilityValue[1] = TB_Sensibility1;
            g_ChannelSensibilityValue[2] = TB_Sensibility2;
            g_ChannelSensibilityValue[3] = TB_Sensibility3;
            g_ChannelSensibilityValue[4] = TB_Sensibility4;
            g_ChannelSensibilityValue[5] = TB_Sensibility5;
            g_ChannelSensibilityValue[6] = TB_Sensibility6;
            g_ChannelSensibilityValue[7] = TB_Sensibility7;
            g_ChannelSensibilityValue[8] = TB_Sensibility8;
            g_ChannelSensibilityValue[9] = TB_Sensibility9;
            g_ChannelSensibilityValue[10] = TB_Sensibility10;
            g_ChannelSensibilityValue[11] = TB_Sensibility11;
            g_ChannelSensibilityValue[12] = TB_Sensibility12;
            g_ChannelSensibilityValue[13] = TB_Sensibility13;
            g_ChannelSensibilityValue[14] = TB_Sensibility14;
            g_ChannelSensibilityValue[15] = TB_Sensibility15;

            g_ChannelOffsetValue[0] = TB_Offset0;
            g_ChannelOffsetValue[1] = TB_Offset1;
            g_ChannelOffsetValue[2] = TB_Offset2;
            g_ChannelOffsetValue[3] = TB_Offset3;
            g_ChannelOffsetValue[4] = TB_Offset4;
            g_ChannelOffsetValue[5] = TB_Offset5;
            g_ChannelOffsetValue[6] = TB_Offset6;
            g_ChannelOffsetValue[7] = TB_Offset7;
            g_ChannelOffsetValue[8] = TB_Offset8;
            g_ChannelOffsetValue[9] = TB_Offset9;
            g_ChannelOffsetValue[10] = TB_Offset10;
            g_ChannelOffsetValue[11] = TB_Offset11;
            g_ChannelOffsetValue[12] = TB_Offset12;
            g_ChannelOffsetValue[13] = TB_Offset13;
            g_ChannelOffsetValue[14] = TB_Offset14;
            g_ChannelOffsetValue[15] = TB_Offset15;

            g_SamplingRate[0] = CB_SamplingRateGroup0;
            g_SamplingRate[1] = CB_SamplingRateGroup1;
            g_SamplingRate[2] = CB_SamplingRateGroup2;
            g_SamplingRate[3] = CB_SamplingRateGroup3;
            g_SamplingRate[4] = CB_SamplingRateGroup4;
            g_SamplingRate[5] = CB_SamplingRateGroup5;
            g_SamplingRate[6] = CB_SamplingRateGroup6;
            g_SamplingRate[7] = CB_SamplingRateGroup7;


            GB_ChannelConfiguration.Enabled = false;
            B_SetConfiguration.Enabled = false;

        }

        private void B_SetConfiguration_Click(object sender, EventArgs e)
        {
            SetConfiguration();
        }


        private void TB_KeyPress_OnlyNumber(object sender, KeyPressEventArgs e)
        {
            if (char.IsDigit(e.KeyChar) || char.IsControl(e.KeyChar) || char.IsPunctuation(e.KeyChar))
                e.Handled = false;
        }

        private void TB_Sensibility8_TextChanged(object sender, EventArgs e)
        {

        }

        private void TB_Sensibility9_TextChanged(object sender, EventArgs e)
        {

        }

        private void TB_Sensibility0_TextChanged(object sender, EventArgs e)
        {

        }
    }
}